	page	80, 128

	TITLE	_asm.ASM

	.286c
	.287

; OBJASM version 2.0 released on Jan 3, 1991
; (C) Copyright 1988,1989,1990,1991 by Robert F. Day.  All rights reserved

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	File:	main.asm
;	Date:	01-May-1998
;	Vers:	0.1
;	Auth:	PJD  Parts Copyright (C) Papa Delta Limited.
;
;	Description:
;	~~~~~~~~~~~~
;	Enhanced version of the Nantucket supplied CLIPPER.LIB module
;	'main' (_asm.ASM), all made possible by the wonderful OBJASM
;	utility by Robert F. Day (see above).  This might have been a
;	standalone module, but it seemed more sensible to incorporate
;	the EPOCH handling in the same place as other startup code and
;	where there is already support for environment checking and
;	parsing.
;
;	The only difference between the code here and that in the
;	originally distributed CLIPPER.LIB is a tiny amount of extra
;	processing of the EPOCH environment variable, if one is set.
;	Summer'87 Clipper does not support EPOCH like 5.x though a
;	standalone module (EPOCH.ASM/EPOCH.OBJ) is available which
;	fixes this lack.  However, the real benefit of having the
;	EPOCH set automatically on startup (from an external variable)
;	is that no source changes are necessary - only relinking with
;	the modified library and a "set epoch=50" or whatever in the
;	PC's AUTOEXEC.BAT.  Note that setting EPOCH here is fully
;	compatible with using the 'epoch()' function in the separate
;	module, though obviously any resetting by the latter will
;	override the EPOCH set in the environment at startup.
;
;	Examples:
;	~~~~~~~~~
;	In AUTOEXEC.BAT (or entered at the DOS prompt)
;	   set EPOCH=80
;	* Sets the EPOCH to [19]80.  Two-digit years less than 80 will
;	* be assumed to refer to 21st century dates.
;
;	Build instructions:
;	~~~~~~~~~~~~~~~~~~~
;	Using MASM:
;
;		masm /mx main;
;
;	This will create the file MAIN.OBJ which can be included as one
;	of the files to the linker (*BEFORE* any libraries are searched),
;	or used to replace the existing MAIN.OBJ in CLIPPER.LIB (this is
;	the preferred method).
;
;	For example, using the MS LIB library editor/manager, use:
;
;	C:\CLIPPER> lib clipper
;	Operations: -+main
;	List file: clipper.lst
;	New name:  clipper.lib
;
;	Note that should should *ALWAYS* take a backup of CLIPPER.LIB
;	before doing this....
;
;
;	Notes and Disclaimers:
;	~~~~~~~~~~~~~~~~~~~~~~
;	This file makes use of the (to my knowledge) undocumented EPOCH
;	support already existing in the Clipper library, at least as far
;	as the file CLIPPER.LIB distributed with the Summer'87 version
;	(the file I have here is 307019 bytes, dated 21/12/87 02:00).
;
;	Disassembly of some of the CLIPPER.LIB modules appears to indicate
;	that the 16-bit word located above the public var '__last_error'
;	in the file '_asm.ASM' CSUPPORT module is indeed the EPOCH word.
;	This variable is static/private, so can only be accessed externally
;	by reference (through its address) in relation to the PUBLIC
;	'__last_error' variable.
;
;	THE MODIFIED SOURCE HERE IS BASED ON THE ASSUMPTION THAT THIS
;	STATIC LOCATION HAS NOT BEEN MOVED OR REMOVED IN OTHER (IF ANY)
;	VERSIONS OF CLIPPER.LIB - USE THIS SOURCE CODE AT YOUR OWN RISK.
;
;	This code is provided strictly "as is" with no warranties etc.
;	that it will work, and absolutely no liability whatsoever is
;	accepted by either me or Papa Delta Limited for any disaster
;	or damage it might cause.  You have been warned!
;
;	That said, it seems to work just fine here...
;
;	Suggestions, possible support and any other correspondence
;	to:
;		pete@pdlmail.demon.co.uk
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN_TEXT	SEGMENT WORD PUBLIC 'CODE'
MAIN_TEXT	ENDS

_DATA	SEGMENT WORD PUBLIC 'DATA'
_DATA	ENDS

CONST	SEGMENT WORD PUBLIC 'CONST'
CONST	ENDS

_BSS	SEGMENT WORD PUBLIC 'BSS'
_BSS	ENDS

DGROUP	GROUP	CONST, _BSS, _DATA

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

retf	MACRO	; MASM4 won't do this without PROC FAR declarations...
db	0CBh
	ENDM

EPOCH_PTR  equ	offset DGROUP:__last_error + 2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; [081E]	; Linker - Pass two marker

	EXTRN		__fault_alloc:NEAR
	EXTRN		__xframe1:WORD
	EXTRN		__xframe0:WORD
	EXTRN		__putsym:NEAR
	EXTRN		__debug_force:WORD
	EXTRN		__system:NEAR
	EXTRN		__twrite:NEAR
	EXTRN		__maxrow:WORD
	EXTRN		__goutnl:NEAR
	EXTRN		__keyset:WORD
	EXTRN		__ierror:NEAR
	EXTRN		__dmytod:NEAR
	EXTRN		__keymgr:NEAR
	EXTRN		__dvinit:NEAR
	EXTRN		__tclose:NEAR
	EXTRN		__getenv:NEAR
	EXTRN		__f_next:NEAR
	EXTRN		__maxcol:WORD
	EXTRN		__colord:WORD
	EXTRN		__upcase:NEAR
	EXTRN		__snap_total:WORD
	EXTRN		__sym_search:NEAR
	EXTRN		__altc_error:NEAR
	EXTRN		__stack_init:NEAR
	EXTRN		__blk_shrink:NEAR
	EXTRN		__alt_handle:WORD
	EXTRN		__emm_handle:WORD
	EXTRN		_strlen:NEAR
	EXTRN		__putcs:NEAR
	EXTRN		__dvtoq:NEAR
	EXTRN		__tinit:NEAR
	EXTRN		__sinit:NEAR
	EXTRN		__pinit:NEAR
	EXTRN		__kinit:NEAR
	EXTRN		__sym_count:NEAR
	EXTRN		__lntoa:NEAR
	EXTRN		__bcopy:NEAR
	EXTRN		_malloc:NEAR
	EXTRN		__dvfml:NEAR
	EXTRN		__tread:NEAR
	EXTRN		__imode:WORD
	EXTRN		__term_init:NEAR
	EXTRN		__bscan:NEAR
	EXTRN		__debug:NEAR
	EXTRN		__reef_init:NEAR
	EXTRN		__pull2:NEAR
	EXTRN		__heap_init:NEAR
	EXTRN		__open_file:NEAR
	EXTRN		__pull1:NEAR
	EXTRN		__default_drive:ABS
	EXTRN		ERRORSYS:NEAR
	EXTRN		__putq:NEAR
	EXTRN		__putl:NEAR
	EXTRN		__scan_filename:NEAR
	EXTRN		__gout:NEAR
	EXTRN		__cout:NEAR
	EXTRN		__exit:NEAR
	EXTRN		__next_sym:NEAR
	EXTRN		__salt:WORD
	EXTRN		__ntoa:NEAR
	EXTRN		__bset:NEAR
	EXTRN		__send:NEAR
	EXTRN		__ntx_init:NEAR
	EXTRN		__sym_init:NEAR
	EXTRN		__dtoa:NEAR
	EXTRN		__eval:WORD
	EXTRN		__pend:NEAR
	EXTRN		__cclr:NEAR
	EXTRN		__kend:NEAR
	EXTRN		__emm_stat:WORD
	EXTRN		__blk_grow:NEAR
	EXTRN		__alt_open:WORD
	EXTRN		__mem_snap:NEAR
	EXTRN		__term_end:NEAR
	EXTRN		__blk_init:NEAR
	EXTRN		__mac_init:NEAR
	EXTRN		__read_var:WORD
	EXTRN		__get_name:NEAR
	EXTRN		__p_handle:WORD
	EXTRN		__debug_active:WORD
	EXTRN		__tos:WORD
	EXTRN		__setcurs:NEAR
	EXTRN		_free:NEAR
	EXTRN		__tunlink:NEAR
	EXTRN		__thcount:NEAR
	EXTRN		__scrsize:WORD
	EXTRN		__no_snow:WORD
	EXTRN		__cin:NEAR
	EXTRN		__brkstat:NEAR
	EXTRN		__get_sym:NEAR
	EXTRN		__saltmem:NEAR
	EXTRN		__ntx_end:NEAR
	EXTRN		__mv_kill:NEAR
	EXTRN		__f_first:NEAR
	EXTRN		__trename:NEAR
	EXTRN		__db_quit:NEAR
	EXTRN		__pid_cls:NEAR
	EXTRN		__asmcall:NEAR
	EXTRN		__phandle:NEAR
	EXTRN		__m_avail:NEAR
	EXTRN		__db_init:NEAR
	EXTRN		__e_avail:NEAR
	EXTRN		__blk_end:NEAR
	EXTRN		__salt_memlen:WORD
	EXTRN		__dbf_dir:NEAR

	EXTRN		__last_error:WORD	; added 01-may-1998

	PUBLIC		__trap_break		; Located at 1:0000h Type = 1
	PUBLIC		__SET_PC		; Located at 1:00A0h Type = 1
	PUBLIC		__CHK_PC		; Located at 1:00B2h Type = 1
	PUBLIC		__C_ALL 		; Located at 1:01B4h Type = 1
	PUBLIC		__DO			; Located at 1:031Ch Type = 1
	PUBLIC		__FUNC			; Located at 1:0362h Type = 1
	PUBLIC		__ENDPROC		; Located at 1:03E6h Type = 1
	PUBLIC		__SAVE_RET		; Located at 1:03E8h Type = 1
	PUBLIC		__mout			; Located at 1:04B4h Type = 1
	PUBLIC		__moutn 		; Located at 1:04D6h Type = 1
	PUBLIC		__QUIT			; Located at 1:0548h Type = 1
	PUBLIC		__mv_alloc		; Located at 1:0616h Type = 1
	PUBLIC		__pv_alloc		; Located at 1:0678h Type = 1
	PUBLIC		__trash 		; Located at 1:06FAh Type = 1
	PUBLIC		__mem_alloc		; Located at 1:0724h Type = 1
	PUBLIC		__try_allocn		; Located at 1:076Ah Type = 1
	PUBLIC		__mem_release		; Located at 1:0790h Type = 1
	PUBLIC		__str_alloc		; Located at 1:07A6h Type = 1
	PUBLIC		__str_release		; Located at 1:07DCh Type = 1
	PUBLIC		__PROCLINE		; Located at 1:07F0h Type = 1
	PUBLIC		__PROCNAME		; Located at 1:080Ah Type = 1
	PUBLIC		PROCFILE		; Located at 1:0876h Type = 1
	PUBLIC		__shark_bait		; Located at 1:08A8h Type = 1
	PUBLIC		__trap_shark		; Located at 1:08E4h Type = 1
	PUBLIC		__fv_alloc		; Located at 1:09BCh Type = 1
	PUBLIC		__fv_release		; Located at 1:09F8h Type = 1
	PUBLIC		__buf_alloc		; Located at 1:0A0Ch Type = 1
	PUBLIC		__buf_release		; Located at 1:0A42h Type = 1
	PUBLIC		__RELEASE		; Located at 1:0A56h Type = 1
	PUBLIC		__XRELEASE		; Located at 1:0AEEh Type = 1
	PUBLIC		__CALL			; Located at 1:0C12h Type = 1
	PUBLIC		__break_cycle		; Located at 1:0DEEh Type = 1
	PUBLIC		__EVENTS		; Located at 1:0E1Eh Type = 1
	PUBLIC		_main			; Located at 1:11E4h Type = 1
	PUBLIC		__os_dir		; Located at 1:12FAh Type = 1
	PUBLIC		__os_copy		; Located at 1:1520h Type = 1
	PUBLIC		__os_type		; Located at 1:162Ch Type = 1
	PUBLIC		__DOS_CALL		; Located at 1:1774h Type = 1
	PUBLIC		__FILE			; Located at 1:189Ah Type = 1
	PUBLIC		__MEMORY		; Located at 1:18C6h Type = 1
	PUBLIC		__PCOUNT		; Located at 1:1902h Type = 1
	PUBLIC		__LINE			; Located at 1:191Ch Type = 1
	PUBLIC		ERRORLEVEL		; Located at 1:1934h Type = 1
	PUBLIC		SETCANCEL		; Located at 1:1990h Type = 1
	PUBLIC		__vcsize		; Located at 2:0000h Type = 4
	PUBLIC		__altc_on		; Located at 2:0002h Type = 4
	PUBLIC		SUMMER87		; Located at 2:0004h Type = 0
	PUBLIC		__quitting		; Located at 2:0012h Type = 4
	PUBLIC		__line_num		; Located at 2:0014h Type = 4
	PUBLIC		__param_count		; Located at 2:0016h Type = 4
	PUBLIC		__mstack		; Located at 2:001Ch Type = 4
	PUBLIC		__mcount		; Located at 2:0020h Type = 4
	PUBLIC		__mtop			; Located at 2:0022h Type = 4
	PUBLIC		__mbp			; Located at 2:0024h Type = 4
	PUBLIC		__ptop			; Located at 2:0026h Type = 4
	PUBLIC		__date_mode		; Located at 2:0028h Type = 4


MAIN_TEXT	SEGMENT
	assume	cs: MAIN_TEXT


__trap_break:
	push	bp
	mov	bp,sp
	sub	sp,+006h
	mov	ax,__imode
	mov	[bp-002h],ax
	assume	ds: DGROUP
	mov	ax,__line_num
	mov	[bp-004h],ax
	mov	ax,[bp+006h]
	sub	ax,0080h
	cmp	ax,0007h
	jnbe	$L1
	add	ax,ax
	xchg	ax,bx
	jmp	cs:[bx+$S2]
	nop
$S4:	cmp	word ptr __altc_on,+000h
	jz	$L1
	call	far ptr __altc_error
	jmp	short $L1
$S5:	call	far ptr __cclr
	sub	ax,ax
	push	ax
	push	ax
	call	far ptr __keymgr
	add	sp,+004h
	mov	[bp-006h],ax
	cmp	ax,0080h
	jz	$L3
	cmp	ax,0083h
	jnz	$L1
$L3:	push	[bp-006h]
	push	cs
	call	__trap_break
	add	sp,+002h
	jmp	short $L1
$S6:	cmp	word ptr __debug_active,+000h
	jz	$L1
	mov	word ptr __debug_force,0001h
	mov	ax,__imode
	cmp	ax,0001h
	jc	$L1
	cmp	ax,0006h
	jnbe	$L1
	call	far ptr __debug
	jmp	short $L1
	nop
$S2	dw	MAIN_TEXT:$S4
	dw	MAIN_TEXT:$S5
	dw	MAIN_TEXT:$L1
	dw	MAIN_TEXT:$S6
	dw	MAIN_TEXT:$L1
	dw	MAIN_TEXT:$L1
	dw	MAIN_TEXT:$L1
	dw	MAIN_TEXT:$L1
$L1:	mov	ax,[bp-002h]
	mov	__imode,ax
	mov	ax,[bp-004h]
	mov	__line_num,ax
	mov	sp,bp
	pop	bp
	retf
__SET_PC:
	push	bp
	mov	bp,sp
	mov	ax,$S7
	mov	$S8,ax
	mov	ax,[bp+006h]
	mov	$S7,ax
	pop	bp
	retf
	nop
__CHK_PC:
	push	bp
	mov	bp,sp
	jmp	short $L9
	nop
$L10:	call	far ptr __pull1
	dec	word ptr __param_count
$L9:	mov	ax,__param_count
	cmp	[bp+006h],ax
	jc	$L10
	jmp	short $L11
	nop
$L12:	add	word ptr __tos,+010h
	les	bx,dword ptr __tos
	mov	word ptr es:[bx],0000h
	inc	word ptr __param_count
$L11:	mov	ax,__param_count
	cmp	[bp+006h],ax
	jnbe	$L12
	pop	bp
	retf
$S17:	push	bp
	mov	bp,sp
	sub	sp,+012h
	jmp	short $L13
$L15:	mov	ax,0016h
	mul	word ptr __mtop
	add	ax,__mstack
	mov	dx,$S14
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	push	dx
	push	ax
	call	far ptr __mv_kill
	add	sp,+004h
	les	bx,dword ptr [bp-004h]
	mov	ax,es:[bx+00Eh]
	mov	dx,es:[bx+010h]
	les	bx,dword ptr es:[bx+012h]
	mov	es:[bx+004h],ax
	mov	es:[bx+006h],dx
	dec	word ptr __mtop
$L13:	mov	ax,__mbp
	cmp	__mtop,ax
	jnbe	$L15
	cmp	ax,0001h
	jbe	$L16
	mov	ax,0016h
	mul	word ptr __mtop
	add	ax,__mstack
	mov	dx,$S14
	mov	[bp-00Eh],ax
	mov	[bp-00Ch],dx
	les	bx,dword ptr [bp-00Eh]
	mov	ax,es:[bx+002h]
	mov	[bp-00Ah],ax
	mov	ax,es:[bx+012h]
	mov	dx,es:[bx+014h]
	mov	[bp-008h],ax
	mov	[bp-006h],dx
	mov	ax,es:[bx]
	mov	__mbp,ax
	dec	word ptr __mtop
	push	cs
	call	$S17
	inc	word ptr __mtop
	mov	ax,0016h
	mul	word ptr __mtop
	add	ax,__mstack
	mov	dx,$S14
	mov	[bp-012h],ax
	mov	[bp-010h],dx
	les	bx,dword ptr [bp-012h]
	mov	ax,[bp-00Ah]
	mov	es:[bx+002h],ax
	mov	ax,[bp-008h]
	mov	dx,[bp-006h]
	mov	es:[bx+012h],ax
	mov	es:[bx+014h],dx
	mov	ax,__mbp
	mov	es:[bx],ax
	mov	ax,__mtop
	mov	__mbp,ax
$L16:	mov	sp,bp
	pop	bp
	retf
__C_ALL:
	push	cs
	call	$S17
	push	cs
	call	$S18
	retf
	nop
$S26:	push	bp
	mov	bp,sp
	sub	sp,+012h
	push	si
	mov	ax,__line_num
	mov	[bp-00Ch],ax
	mov	ax,$S8
	mov	[bp-00Ah],ax
	mov	ax,__param_count
	mov	[bp-00Eh],ax
	mov	ax,$S7
	mov	__param_count,ax
	mov	ax,__tos
	mov	dx,__tos + 00002h
	mov	bx,__param_count
	mov	cl,04h
	shl	bx,cl
	sub	ax,bx
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	mov	ax,0016h
	mul	word ptr __mbp
	mov	si,ax
	les	bx,dword ptr __mstack
	mov	ax,__line_num
	mov	es:[bx+si+002h],ax
	mov	word ptr __line_num,0000h
	inc	word ptr __mtop
	mov	ax,0016h
	mul	word ptr __mtop
	add	ax,bx
	mov	dx,es
	mov	[bp-012h],ax
	mov	[bp-010h],dx
	les	bx,dword ptr [bp-012h]
	mov	ax,__mbp
	mov	es:[bx],ax
	mov	ax,[bp+006h]
	mov	dx,[bp+008h]
	mov	es:[bx+012h],ax
	mov	es:[bx+014h],dx
	mov	word ptr es:[bx+002h],0000h
	mov	ax,__mtop
	mov	__mbp,ax
	les	bx,dword ptr [bp+006h]
	call	dword ptr es:[bx+00Eh]
	cmp	word ptr __salt,+065h
	jnz	$L19
$L20:	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	mov	bx,__param_count
	mov	cl,04h
	shl	bx,cl
	add	ax,bx
	cmp	ax,__tos
	jnc	$L19
	call	far ptr __pull1
	jmp	short $L20
	nop
$L21:	call	far ptr __pull1
	dec	word ptr __param_count
$L19:	cmp	word ptr __param_count,+000h
	jnz	$L21
	jmp	short $L22
$L23:	mov	ax,0016h
	mul	word ptr __mtop
	add	ax,__mstack
	mov	dx,$S14
	mov	[bp-008h],ax
	mov	[bp-006h],dx
	push	dx
	push	ax
	call	far ptr __mv_kill
	add	sp,+004h
	les	bx,dword ptr [bp-008h]
	mov	ax,es:[bx+00Eh]
	mov	dx,es:[bx+010h]
	les	bx,dword ptr es:[bx+012h]
	mov	es:[bx+004h],ax
	mov	es:[bx+006h],dx
	dec	word ptr __mtop
$L22:	mov	ax,__mbp
	cmp	__mtop,ax
	jnbe	$L23
	mov	ax,0016h
	mul	word ptr __mtop
	mov	bx,ax
	les	si,dword ptr __mstack
	mov	ax,es:[bx+si]
	mov	__mbp,ax
	dec	word ptr __mtop
	mov	ax,[bp-00Ch]
	mov	__line_num,ax
	mov	ax,[bp-00Ah]
	mov	$S7,ax
	mov	ax,[bp-00Eh]
	mov	__param_count,ax
	mov	ax,__eval
	mov	dx,__eval + 00002h
	cmp	__tos,ax
	jnc	$L24
	mov	ax,0001h
	push	ax
	call	far ptr __ierror
	add	sp,+002h
	mov	ax,__eval
	mov	dx,__eval + 00002h
	mov	__tos,ax
	mov	__tos + 00002h,dx
$L24:	pop	si
	mov	sp,bp
	pop	bp
	retf
__DO:	push	bp
	mov	bp,sp
	sub	sp,+004h
	les	bx,dword ptr __tos
	mov	ax,es:[bx+008h]
	mov	dx,es:[bx+00Ah]
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	or	ax,dx
	jz	$L25
	les	bx,dword ptr [bp-004h]
	mov	ax,es:[bx+00Eh]
	or	ax,es:[bx+010h]
	jz	$L25
	sub	word ptr __tos,+010h
	push	dx
	push	bx
	push	cs
	call	$S26
	add	sp,+004h
	mov	sp,bp
	pop	bp
	retf
	nop
$L25:	mov	word ptr __salt,0003h
	mov	sp,bp
	pop	bp
	retf
__FUNC: push	bp
	mov	bp,sp
	sub	sp,+004h
	les	bx,dword ptr __tos
	mov	ax,es:[bx+008h]
	mov	dx,es:[bx+00Ah]
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	or	ax,dx
	jz	$L27
	les	bx,dword ptr [bp-004h]
	mov	ax,es:[bx+00Eh]
	or	ax,es:[bx+010h]
	jz	$L27
	sub	word ptr __tos,+010h
	push	dx
	push	bx
	push	cs
	call	$S26
	add	sp,+004h
	add	word ptr __tos,+010h
	mov	ax,0010h
	push	ax
	push	__eval + 00002h
	push	__eval
	push	__tos + 00002h
	push	__tos
	call	far ptr __bcopy
	add	sp,+00Ah
	les	bx,dword ptr __tos
	cmp	word ptr es:[bx],+000h
	jnz	$L28
	mov	word ptr es:[bx],0080h
	mov	word ptr es:[bx+008h],0000h
$L28:	les	bx,dword ptr __eval
	mov	word ptr es:[bx],0000h
	mov	sp,bp
	pop	bp
	retf
$L27:	mov	word ptr __salt,0003h
	mov	sp,bp
	pop	bp
	retf
__ENDPROC:
	retf
	nop
__SAVE_RET:
	push	bp
	mov	bp,sp
	sub	sp,+006h
	push	di
	push	si
	les	bx,dword ptr __eval
	test	word ptr es:[bx],0100h
	jz	$L29
	push	es

	push	bx
	push	cs
	call	__trash
	add	sp,+004h
$L29:	les	bx,dword ptr __eval
	mov	ax,__tos
	mov	dx,__tos + 00002h
	push	si
	mov	di,bx
	mov	si,ax
	push	ds
	mov	ds,dx
	mov	cx,0008h
	repz	movsw
	pop	ds
	pop	si
	test	word ptr es:[bx],0100h
	jnz	$L30
	jmp	$S31
$L30:	cmp	word ptr es:[bx+00Ch],+000h
	jnz	$S31
	mov	ax,es:[bx+002h]
	mov	[bp-006h],ax
	mov	si,ax
	inc	si
	push	si
	lea	ax,[bp-004h]
	push	ss
	push	ax
	push	cs
	call	__mem_alloc
	add	sp,+006h
	or	ax,ax
	jz	$L32
	push	[bp-006h]
	les	bx,dword ptr __tos
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	push	[bp-002h]
	push	[bp-004h]
	call	far ptr __bcopy
	add	sp,+00Ah
	mov	bx,[bp-006h]
	les	di,dword ptr [bp-004h]
	mov	byte ptr es:[bx+di],00h
	les	bx,dword ptr __eval
	mov	es:[bx+00Ch],si
	mov	ax,di
	mov	dx,[bp-002h]
	mov	es:[bx+008h],ax
	mov	es:[bx+00Ah],dx
	jmp	short $S31
$L32:	les	bx,dword ptr __eval
	mov	word ptr es:[bx+002h],0000h
	mov	ax,offset DGROUP:$S33
	mov	es:[bx+008h],ax
	mov	word ptr es:[bx+00Ah],ds
	mov	word ptr es:[bx+00Ch],0000h
	mov	word ptr __salt,0004h
$S31:	sub	word ptr __tos,+010h
	pop	si
	pop	di
	mov	sp,bp
	pop	bp
	retf
__mout: push	bp
	mov	bp,sp
	push	[bp+008h]
	push	[bp+006h]
	call	far ptr _strlen
	add	sp,+004h
	push	ax
	push	[bp+008h]
	push	[bp+006h]
	call	far ptr __cout
	add	sp,+006h
	pop	bp
	retf
__moutn:
	push	bp
	mov	bp,sp
	sub	sp,+00Eh
	push	si
	cmp	word ptr [bp+00Eh],+00Ah
	jbe	$L34
	mov	word ptr [bp+00Eh],000Ah
$L34:	sub	ax,ax
	push	ax
	cmp	[bp+00Eh],ax
	jz	$L35
	mov	ax,[bp+00Eh]
	jmp	short $L36
	nop
$L35:	mov	ax,000Ah
$L36:	push	ax
	push	[bp+00Ch]
	push	[bp+00Ah]
	lea	ax,[bp-00Ch]
	push	ss
	push	ax
	call	far ptr __lntoa
	add	sp,+00Ch
	mov	word ptr [bp-00Eh],0000h
	cmp	word ptr [bp+00Eh],+000h
	jnz	$L37
	jmp	short $L38
$L39:	inc	word ptr [bp-00Eh]
$L38:	mov	si,[bp-00Eh]
	cmp	byte ptr [bp+si-00Ch],20h
	jz	$L39
$L37:	push	[bp+008h]
	push	[bp+006h]
	push	cs
	call	__mout
	add	sp,+004h
	mov	si,[bp-00Eh]
	lea	ax,[bp+si-00Ch]
	push	ss
	push	ax
	push	cs
	call	__mout
	add	sp,+004h
	pop	si
	mov	sp,bp
	pop	bp
	retf
	nop
__QUIT: push	bp
	mov	bp,sp
	sub	sp,+002h
	inc	word ptr __quitting
	cmp	word ptr __quitting,+014h
	jbe	$L40
	mov	ax,0001h
	push	ax
	call	far ptr __exit
	add	sp,+002h
$L40:	cmp	word ptr __quitting,+005h
	jnc	$L41
	call	far ptr __db_quit
$L41:	mov	word ptr __quitting,0014h
	cmp	word ptr __alt_open,+000h
	jz	$L42
	mov	ax,0001h
	push	ax
	mov	ax,offset DGROUP:$S43
	push	ds
	push	ax
	push	__alt_handle
	call	far ptr __twrite
	add	sp,+008h
	push	__alt_handle
	call	far ptr __tclose
	add	sp,+002h
	mov	word ptr __alt_open,0000h
$L42:	cmp	word ptr __p_handle,+000h
	jz	$L44
	push	__p_handle
	call	far ptr __tclose
	add	sp,+002h
	mov	word ptr __p_handle,0000h
	mov	ax,0004h
	push	ax
	call	far ptr __phandle
	add	sp,+002h
$L44:	call	far ptr __term_end
	call	far ptr __ntx_end
	call	far ptr __blk_end
	call	far ptr __pend
	call	far ptr __kend
	call	far ptr __send
	push	$S45
	call	far ptr __exit
	mov	sp,bp
	pop	bp
	retf
	nop
	cmp	word ptr __emm_stat,+000h
	jz	$L46
	push	__emm_handle
	call	far ptr __pid_cls
	add	sp,+002h
$L46:	mov	ax,0001h
	push	ax
	call	far ptr __exit
	add	sp,+002h
	retf
__mv_alloc:
	push	bp
	mov	bp,sp
	sub	sp,+004h
	mov	ax,[bp+006h]
	add	ax,__mtop
	cmp	ax,__ptop
	jnc	$L47
	mov	ax,0016h
	mul	word ptr __mtop
	add	ax,__mstack
	mov	dx,$S14
	add	ax,0016h
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	les	bx,dword ptr [bp-004h]
	mov	word ptr es:[bx],0000h
	mov	ax,[bp+006h]
	add	__mtop,ax
	mov	ax,bx
	mov	sp,bp
	pop	bp
	retf
$L47:	mov	ax,offset DGROUP:$S48
	push	ds
	push	ax
	mov	ax,0016h
	push	ax
	call	far ptr __saltmem
	add	sp,+006h
	les	bx,dword ptr __mstack
	mov	word ptr es:[bx],0000h
	mov	ax,bx
	mov	dx,es
	mov	sp,bp
	pop	bp
	retf
__pv_alloc:
	push	bp
	mov	bp,sp
	mov	ax,__ptop
	dec	ax
	cmp	ax,__mtop
	jbe	$L49
	dec	word ptr __ptop
	mov	ax,0016h
	mul	word ptr __ptop
	add	ax,__mstack
$L51:	mov	dx,$S14
	pop	bp
	retf
$L49:	mov	ax,offset DGROUP:$S50
	push	ds
	push	ax
	mov	ax,0016h
	push	ax
	call	far ptr __saltmem
	add	sp,+006h
	mov	ax,__mstack
	jmp	short $L51
$S18:	push	bp
	mov	bp,sp
	sub	sp,+004h
	jmp	short $L52
$L53:	mov	ax,0016h
	mul	word ptr __ptop
	add	ax,__mstack
	mov	dx,$S14
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	push	dx
	push	ax
	call	far ptr __mv_kill
	add	sp,+004h
	les	bx,dword ptr [bp-004h]
	les	bx,dword ptr es:[bx+012h]
	sub	ax,ax
	mov	es:[bx+006h],ax
	mov	es:[bx+004h],ax
	inc	word ptr __ptop
$L52:	mov	ax,__mcount
	cmp	__ptop,ax
	jc	$L53
	mov	sp,bp
	pop	bp
	retf
	nop
__trash:
	push	bp
	mov	bp,sp
	les	bx,dword ptr [bp+006h]
	test	word ptr es:[bx],0100h
	jz	$L54
	cmp	word ptr es:[bx+00Ch],+000h
	jz	$L54
	push	es:[bx+00Ch]
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	push	cs
	call	__str_release
	add	sp,+006h
$L54:	pop	bp
	retf
	nop
__mem_alloc:
	push	bp
	mov	bp,sp
	push	[bp+00Ah]
	call	far ptr _malloc
	add	sp,+002h
	les	bx,dword ptr [bp+006h]
	mov	es:[bx],ax
	mov	es:[bx+002h],dx
	or	ax,dx
	jz	$L55
$L56:	mov	ax,0001h
	pop	bp
	retf
	nop
$L55:	push	[bp+00Ah]
	push	es
	push	bx
	call	far ptr __fault_alloc
	add	sp,+006h
	les	bx,dword ptr [bp+006h]
	mov	ax,es:[bx]
	or	ax,es:[bx+002h]
	jnz	$L56
	mov	word ptr __salt,0004h
	sub	ax,ax
	pop	bp
	retf
	nop
__try_allocn:
	push	bp
	mov	bp,sp
	push	[bp+00Ah]
	call	far ptr _malloc
	add	sp,+002h
	les	bx,dword ptr [bp+006h]
	mov	es:[bx],ax
	mov	es:[bx+002h],dx
	or	ax,dx
	jz	$L57
	mov	ax,0001h
	pop	bp
	retf
	nop
$L57:	sub	ax,ax
	pop	bp
	retf
__mem_release:
	push	bp
	mov	bp,sp
	push	[bp+008h]
	push	[bp+006h]
	call	far ptr _free
	add	sp,+004h
	mov	ax,0001h
	pop	bp
	retf
__str_alloc:
	push	bp
	mov	bp,sp
	sub	sp,+004h
	push	[bp+006h]
	call	far ptr _malloc
	add	sp,+002h
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	or	ax,dx
	jnz	$L58
	push	[bp+006h]
	lea	ax,[bp-004h]
	push	ss
	push	ax
	call	far ptr __fault_alloc
	add	sp,+006h
$L58:	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	mov	sp,bp
	pop	bp
	retf
	nop
__str_release:
	push	bp
	mov	bp,sp
	push	[bp+008h]
	push	[bp+006h]
	call	far ptr _free
	add	sp,+004h
	pop	bp
	retf
	nop
__PROCLINE:
	mov	word ptr __xframe0,0002h
	mov	word ptr __xframe0 + 00002h,000Ah

	mov	ax,__line_num
	mov	__xframe0 + 00008h,ax
	mov	word ptr __xframe0 + 0000Ah,0000h
	retf
	nop
__PROCNAME:
	push	bp
	mov	bp,sp
	sub	sp,+004h
	push	si
	cmp	word ptr __mbp,+000h
	jz	$L59
	mov	ax,0016h
	mul	word ptr __mbp
	mov	si,ax
	les	bx,dword ptr __mstack
	push	es:[bx+si+014h]
	push	es:[bx+si+012h]
	call	far ptr __get_name
	add	sp,+004h
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	jmp	short $L60
	nop
$L59:	mov	ax,offset DGROUP:$S61
	mov	[bp-004h],ax
	mov	word ptr [bp-002h],ds
$L60:	mov	word ptr __xframe0,0100h
	push	[bp-002h]
	push	[bp-004h]
	call	far ptr _strlen
	add	sp,+004h
	mov	__xframe0 + 00002h,ax
	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	mov	__xframe0 + 00008h,ax
	mov	__xframe0 + 0000Ah,dx
	mov	word ptr __xframe0 + 0000Ch,0000h
	pop	si
	mov	sp,bp
	pop	bp
	retf
PROCFILE:
	push	bp
	mov	bp,sp
	sub	sp,+004h
	lea	ax,[bp-004h]
	push	ss
	push	ax
	call	far ptr __sym_count
	add	sp,+004h
	sub	ax,ax
	push	ax
	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	add	ax,0010h
	push	dx
	push	ax
	call	far ptr __putcs
	add	sp,+006h
	push	cs
	call	__SAVE_RET
	mov	sp,bp
	pop	bp
	retf
	nop
__shark_bait:
	push	bp
	mov	bp,sp
	sub	sp,+002h
	mov	word ptr [bp-002h],0000h
$L63:	mov	bx,[bp-002h]
	mov	ax,bx
	shl	bx,1
	add	bx,ax
	shl	bx,1
	mov	ax,[bp+006h]
	cmp	[bx+__keyset],ax
	jz	$L62
	inc	word ptr [bp-002h]
	cmp	word ptr [bp-002h],+021h
	jc	$L63
$L62:	cmp	word ptr [bp-002h],+021h
	jnc	$L64
	mov	ax,0001h
	mov	sp,bp
	pop	bp
	retf
	nop
$L64:	sub	ax,ax
	mov	sp,bp
	pop	bp
	retf
__trap_shark:
	push	bp
	mov	bp,sp
	sub	sp,+00Ah
	push	si
	mov	ax,__imode
	mov	[bp-006h],ax
	mov	ax,__line_num
	mov	[bp-008h],ax
	mov	word ptr [bp-00Ah],0000h
$L66:	mov	bx,[bp-00Ah]
	mov	ax,bx
	shl	bx,1
	add	bx,ax
	shl	bx,1
	mov	ax,[bp+006h]
	cmp	[bx+__keyset],ax
	jz	$L65
	inc	word ptr [bp-00Ah]
	cmp	word ptr [bp-00Ah],+021h
	jc	$L66
$L65:	cmp	word ptr [bp-00Ah],+021h
	jc	$L67
	jmp	$S68
$L67:	mov	bx,[bp-00Ah]
	mov	ax,bx
	shl	bx,1
	add	bx,ax
	shl	bx,1
	mov	ax,[bx+__keyset + 00002h]
	mov	dx,[bx+__keyset + 00004h]
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	or	dx,ax
	jz	$S68
	mov	word ptr __imode,0000h
	sub	ax,ax
	push	ax
	mov	ax,0016h
	mul	word ptr __mbp
	mov	si,ax
	les	bx,dword ptr __mstack
	push	es:[bx+si+014h]
	push	es:[bx+si+012h]
	call	far ptr __get_name
	add	sp,+004h
	push	dx
	push	ax
	call	far ptr __putcs
	add	sp,+006h
	push	__line_num
	call	far ptr __putq
	add	sp,+002h
	sub	ax,ax
	push	ax
	push	__read_var + 00002h
	push	__read_var
	call	far ptr __putcs
	add	sp,+006h
	mov	ax,0003h
	push	ax
	push	cs
	call	__SET_PC
	add	sp,+002h
	push	[bp-002h]
	push	[bp-004h]
	call	far ptr __putsym
	add	sp,+004h
	push	cs
	call	__DO
$S68:	mov	ax,[bp-006h]
	mov	__imode,ax
	mov	ax,[bp-008h]
	mov	__line_num,ax
	pop	si
	mov	sp,bp
	pop	bp
	retf
__fv_alloc:
	push	bp
	mov	bp,sp
	sub	sp,+004h
	push	si
	mov	ax,0012h
	mul	word ptr [bp+006h]
	mov	si,ax
	push	si
	call	far ptr _malloc
	add	sp,+002h
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	or	ax,dx
	jnz	$L69
	push	si
	lea	ax,[bp-004h]
	push	ss
	push	ax
	call	far ptr __fault_alloc
	add	sp,+006h
$L69:	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	pop	si
	mov	sp,bp
	pop	bp
	retf
	nop
__fv_release:
	push	bp
	mov	bp,sp
	push	[bp+008h]
	push	[bp+006h]
	call	far ptr _free
	add	sp,+004h
	pop	bp
	retf
	nop
__buf_alloc:
	push	bp
	mov	bp,sp
	sub	sp,+004h
	push	[bp+006h]
	call	far ptr _malloc
	add	sp,+002h
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	or	ax,dx
	jnz	$L70
	push	[bp+006h]
	lea	ax,[bp-004h]
	push	ss
	push	ax
	call	far ptr __fault_alloc
	add	sp,+006h
$L70:	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	mov	sp,bp
	pop	bp
	retf
	nop
__buf_release:
	push	bp
	mov	bp,sp
	push	[bp+008h]
	push	[bp+006h]
	call	far ptr _free
	add	sp,+004h
	pop	bp
	retf
	nop
__RELEASE:
	push	bp
	mov	bp,sp
	sub	sp,+008h
	les	bx,dword ptr __tos
	test	word ptr es:[bx-010h],0100h
	jz	$L71
	push	es:[bx+008h]
	push	es:[bx-006h]
	push	es:[bx-008h]
	call	far ptr __sym_search
	add	sp,+006h
$L73:	call	far ptr __next_sym
	mov	[bp-008h],ax
	mov	[bp-006h],dx
	or	dx,ax
	jz	$L72
	les	bx,dword ptr [bp-008h]
	mov	ax,es:[bx+004h]
	mov	dx,es:[bx+006h]
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	or	dx,ax
	jz	$L73
	mov	ax,0016h
	mul	word ptr __mbp
	add	ax,__mstack
	mov	dx,$S14
	cmp	ax,[bp-004h]
	jnc	$L73
	mov	ax,0016h
	mul	word ptr __mtop
	add	ax,__mstack
	mov	dx,$S14
	cmp	ax,[bp-004h]
	jc	$L73
	push	[bp-002h]
	push	[bp-004h]
	call	far ptr __mv_kill
	add	sp,+004h
	jmp	short $L73
	nop
	nop
$L72:	call	far ptr __pull2
	mov	sp,bp
	pop	bp
	retf
	nop
$L71:	mov	word ptr __salt,0001h
	mov	sp,bp
	pop	bp
	retf
__XRELEASE:
	push	bp
	mov	bp,sp
	sub	sp,+010h
	les	bx,dword ptr __tos
	mov	ax,es:[bx+008h]
	mov	dx,es:[bx+00Ah]
	mov	[bp-008h],ax
	mov	[bp-006h],dx
	sub	word ptr __tos,+010h
	les	bx,dword ptr [bp-008h]
	mov	ax,es:[bx+004h]
	mov	dx,es:[bx+006h]
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	or	dx,ax
	jnz	$L74
	jmp	$S75
$L74:	push	[bp-002h]
	push	ax
	call	far ptr __mv_kill
	add	sp,+004h
	mov	ax,0016h
	mul	word ptr __ptop
	add	ax,__mstack
	mov	dx,$S14
	mov	[bp-010h],ax
	mov	[bp-00Eh],dx
	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	cmp	[bp-010h],ax
	jbe	$L76
	jmp	$S77
$L76:	mov	ax,0016h
	push	ax
	push	[bp-00Eh]
	push	[bp-010h]
	push	dx
	push	[bp-004h]
	call	far ptr __bcopy
	add	sp,+00Ah
	mov	ax,0016h
	mul	word ptr __ptop
	add	ax,__mstack
	mov	dx,$S14
	les	bx,dword ptr [bp-004h]
	les	bx,dword ptr es:[bx+012h]
	cmp	es:[bx+004h],ax
	jnz	$L78
	cmp	es:[bx+006h],dx
	jnz	$L78
	les	bx,dword ptr [bp-004h]
	les	bx,dword ptr es:[bx+012h]
	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	mov	es:[bx+004h],ax
	mov	es:[bx+006h],dx
	jmp	short $L79
	nop
$L78:	les	bx,dword ptr [bp-004h]
	les	bx,dword ptr es:[bx+012h]
	mov	ax,es:[bx+004h]
	mov	dx,es:[bx+006h]
$L82:	mov	[bp-00Ch],ax
	mov	[bp-00Ah],dx
	mov	ax,0016h
	mul	word ptr __ptop
	add	ax,__mstack
	mov	dx,$S14
	les	bx,dword ptr [bp-00Ch]
	cmp	ax,es:[bx+00Eh]
	jnz	$L80
	cmp	dx,es:[bx+010h]
	jz	$L81
$L80:	mov	ax,es:[bx+00Eh]
	mov	dx,es:[bx+010h]
	jmp	short $L82
	nop
$L81:	mov	ax,[bp-004h]
	mov	dx,[bp-002h]
	mov	es:[bx+00Eh],ax
	mov	es:[bx+010h],dx
$L79:	les	bx,dword ptr [bp-008h]
	sub	ax,ax
	mov	es:[bx+006h],ax

	mov	es:[bx+004h],ax
	inc	word ptr __ptop
	mov	sp,bp
	pop	bp
	retf
	nop
$S77:	les	bx,dword ptr [bp-004h]
	mov	word ptr es:[bx],0000h
$S75:	mov	sp,bp
	pop	bp
	retf
$S87:	retf
	nop
__CALL: push	bp
	mov	bp,sp
	sub	sp,+03Ch
	push	di
	push	si
	les	bx,dword ptr __tos
	mov	ax,es:[bx+008h]
	mov	dx,es:[bx+00Ah]
	mov	[bp-016h],ax
	mov	[bp-014h],dx
	or	ax,dx
	jz	$L83
	les	bx,dword ptr [bp-016h]
	mov	ax,es:[bx+00Eh]
	or	ax,es:[bx+010h]
	jnz	$L84
$L83:	mov	word ptr __salt,0003h
	pop	si
	pop	di
	mov	sp,bp
	pop	bp
	retf
	nop
$L84:	sub	word ptr __tos,+010h
	mov	ax,__line_num
	mov	[bp-010h],ax
	mov	ax,$S8
	mov	[bp-00Eh],ax
	mov	ax,__param_count
	mov	[bp-01Ah],ax
	mov	ax,$S7
	mov	__param_count,ax
	mov	word ptr [bp-01Ch],0000h
	mov	ax,__tos
	mov	dx,__tos + 00002h
	mov	[bp-00Ch],ax
	mov	[bp-00Ah],dx
	mov	ax,__param_count
	mov	[bp-012h],ax
	jmp	short $L85
	nop
$S102:	les	bx,dword ptr [bp-00Ch]
	mov	ax,es:[bx+008h]
	mov	dx,es:[bx+00Ah]
$S97:	mov	[bp-004h],ax
	mov	[bp-002h],dx
	mov	word ptr [bp-018h],0001h
$S98:	cmp	word ptr [bp-012h],0100h
	jnz	$L86
	lea	ax,[bp-004h]
	push	ss
	push	ax
	push	cs
	call	$S87
	add	sp,+004h
$L86:	cmp	word ptr [bp-018h],+000h
	jz	$L88
	mov	si,[bp-01Ch]
	inc	word ptr [bp-01Ch]
	shl	si,1
	mov	ax,[bp-002h]
	mov	[bp+si-03Ch],ax
$L88:	mov	si,[bp-01Ch]
	inc	word ptr [bp-01Ch]
	shl	si,1
	mov	ax,[bp-004h]
	mov	[bp+si-03Ch],ax
$L91:	sub	word ptr [bp-00Ch],+010h
	dec	word ptr [bp-012h]
$L85:	cmp	word ptr [bp-012h],+000h
	jg	$L89
	jmp	$S90
$L89:	cmp	word ptr [bp-012h],+008h
	jnl	$L91
	les	bx,dword ptr [bp-00Ch]
	mov	ax,es:[bx]
	cmp	ax,0020h
	jz	$L92
	jbe	$L93
	jmp	$S94
$L93:	cmp	ax,0001h
	jz	$L95
	cmp	ax,0002h
	jnz	$L96
$L92:	les	bx,dword ptr [bp-00Ch]
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	call	far ptr __dvfml
	add	sp,+004h
	les	bx,dword ptr [bp-00Ch]
	lea	di,[bx+008h]
	mov	si,ax
	push	ds
	mov	ds,dx
	movsw
	movsw
	movsw
	movsw
	pop	ds
$L96:	mov	ax,[bp-00Ch]
	mov	dx,[bp-00Ah]
	add	ax,0008h
	jmp	$S97
$L95:	les	bx,dword ptr [bp-00Ch]
	mov	ax,es:[bx+008h]
	mov	[bp-004h],ax
	mov	word ptr [bp-018h],0000h
	jmp	$S98
$L104:	les	bx,dword ptr [bp-00Ch]
	mov	ax,es:[bx+008h]
	mov	dx,es:[bx+00Ah]
	mov	[bp-008h],ax
	mov	[bp-006h],dx
	les	bx,dword ptr [bp-008h]
	mov	ax,es:[bx]
	cmp	ax,0002h
	jz	$L99
	cmp	ax,0008h
	jz	$L99
	cmp	ax,0020h
	jz	$L99
	cmp	ax,0080h
	jz	$L99
	cmp	ax,0100h
	jz	$L100
	cmp	ax,0300h
	jz	$L100
$L99:	mov	ax,bx
	mov	dx,es
	add	ax,0006h
	jmp	$S97
	nop
$L100:	mov	ax,es:[bx+006h]
	mov	dx,es:[bx+008h]
	jmp	$S97
	nop
$S94:	cmp	ax,0080h
	jz	$L96
	cmp	ax,0100h
	jnz	$L101
	jmp	$S102
$L101:	cmp	ax,0300h
	jnz	$L103
	jmp	$S102
$L103:	cmp	ax,0800h
	jz	$L104
	jmp	$L96
	nop
$S90:	push	[bp-01Ch]
	lea	ax,[bp-03Ch]
	push	ss
	push	ax
	les	bx,dword ptr [bp-016h]
	push	es:[bx+010h]
	push	es:[bx+00Eh]
	call	far ptr __asmcall
	add	sp,+00Ah
	jmp	short $L105
	nop
$L106:	call	far ptr __pull1
	dec	word ptr __param_count
$L105:	cmp	word ptr __param_count,+000h
	jnz	$L106
	mov	ax,[bp-010h]
	mov	__line_num,ax
	mov	ax,[bp-00Eh]
	mov	$S7,ax
	mov	ax,[bp-01Ah]
	mov	__param_count,ax
	pop	si
	pop	di
	mov	sp,bp
	pop	bp
	retf
__break_cycle:
	push	bp
	mov	bp,sp
	sub	sp,+002h
	call	far ptr __brkstat
	mov	[bp-002h],ax
	or	ax,ax
	jz	$L107
	cmp	ax,0080h
	jc	$L107
	cmp	ax,0087h
	jnbe	$L107
	call	far ptr __cin
	mov	[bp-002h],ax
	push	ax
	push	cs
	call	__trap_break
	add	sp,+002h
$L107:	mov	sp,bp
	pop	bp
	retf
__EVENTS:
	push	cs
	call	__break_cycle
	retf
	nop
$S119:	push	bp
	mov	bp,sp
	sub	sp,+004h
	mov	word ptr [bp-002h],0000h
	jmp	short $L108
	nop
$L110:	cmp	byte ptr [bp-004h],30h
	jc	$L109
	cmp	byte ptr [bp-004h],39h
	jnbe	$L109
	mov	ax,[bp-002h]
	mov	cx,ax
	shl	ax,1
	shl	ax,1
	add	ax,cx
	shl	ax,1
	les	bx,dword ptr [bp+006h]
	inc	word ptr [bp+006h]
	mov	cl,es:[bx]
	sub	ch,ch
	add	ax,cx
	sub	ax,0030h
	mov	[bp-002h],ax
$L108:	les	bx,dword ptr [bp+006h]
	mov	al,es:[bx]
	mov	[bp-004h],al
	or	al,al
	jnz	$L110
$L109:	mov	ax,[bp-002h]
	mov	sp,bp
	pop	bp
	retf
$S128:	push	bp
	mov	bp,sp
	sub	sp,+004h
	mov	ax,offset DGROUP:$S111
	push	ds
	push	ax
	call	far ptr __getenv
	add	sp,+004h
	mov	[bp-004h],ax
	mov	[bp-002h],dx
	jmp	$S112
$S127:	inc	word ptr [bp-004h]
	mov	al,es:[bx]
	sub	ah,ah
	push	ax
	call	far ptr __upcase
	add	sp,+002h
	sub	ah,ah
	cmp	ax,0045h
	jz	$L113
	cmp	ax,0046h
	jz	$L114
	cmp	ax,0052h
	jz	$L115
	cmp	ax,0053h
	jz	$L116
	cmp	ax,0056h
	jz	$L117
	cmp	ax,0058h
	jz	$L118
	jmp	short $S112
	nop
$L117:	push	[bp-002h]
	push	[bp-004h]
	push	cs
	call	$S119
	add	sp,+004h
	mov	$S120,ax
	jmp	short $S112
$L115:	push	[bp-002h]
	push	[bp-004h]
	push	cs
	call	$S119
	add	sp,+004h
	mov	$S121,ax
	or	ax,ax
	jnz	$S112
	mov	word ptr $S121,0FFFFh
	jmp	short $S112
$L113:	push	[bp-002h]
	push	[bp-004h]
	push	cs
	call	$S119
	add	sp,+004h
	mov	$S122,ax
	or	ax,ax
	jnz	$S112
	mov	word ptr $S122,0FFFFh
	jmp	short $S112
$L118:	push	[bp-002h]
	push	[bp-004h]
	push	cs
	call	$S119
	add	sp,+004h
	mov	$S123,ax
	jmp	short $S112
$L114:	push	[bp-002h]
	push	[bp-004h]
	push	cs
	call	$S119
	add	sp,+004h
	mov	$S124,ax
	jmp	short $S112
$L116:	push	[bp-002h]
	push	[bp-004h]
	push	cs
	call	$S119
	add	sp,+004h
	mov	$S125,ax
$S112:	les	bx,dword ptr [bp-004h]
	cmp	byte ptr es:[bx],00h
	jz	$L126_insert		;extra EPOCH handling: 01-may-98
	jmp	$S127

$L126_insert:				;check for EPOCH set in environment
	mov	ax,offset DGROUP:$X111	;"EPOCH"
	push	ds			;
	push	ax			;
	call	far ptr __getenv	;
	add	sp,+004h		;
	mov	bx,ax			;
	or	bx,dx			;
	jz	$L126			;ignore if NULL pointer
					;
	push	dx			;segment
	push	ax			;offset
	push	cs			;(for the RETF)
	call	$S119			;evaluate to AX
	add	sp,+004h		;
	cmp	ax,99			;only accept range 00-99
	ja	$L126			;ignore if not
					;
	push	si			;do preserve...
	mov	si, EPOCH_PTR		;
	mov	[si], ax		;install new value
	pop	si			;
					;
$L126:	mov	sp,bp			;back to original code...
	pop	bp
	retf
$S165:	push	bp
	mov	bp,sp
	sub	sp,+00Ch
	call	far ptr __sinit
	call	far ptr __kinit
	call	far ptr __pinit
	call	far ptr __dvinit
	call	far ptr __tinit
	push	cs
	call	$S128
	cmp	word ptr $S125,+000h
	jz	$L129
	cmp	word ptr __colord,+000h
	jz	$L129
	mov	word ptr __no_snow,0001h
$L129:	cmp	word ptr __scrsize,+000h
	jz	$L130
	mov	ax,__maxrow
	mul	word ptr __maxcol
	mov	cx,ax
	mov	ax,__scrsize
	sub	dx,dx
	div	cx
	mov	__vcsize,ax
$L130:	cmp	word ptr $S124,+000h
	jz	$L131
	push	$S124
	call	far ptr __thcount
	add	sp,+002h
	or	ax,ax
	jnz	$L131
	mov	ax,0002h
	mov	sp,bp
	pop	bp
	retf
	nop
$L131:	call	far ptr __m_avail
	mov	cl,06h
	shr	ax,cl
	mov	[bp-002h],ax
	cmp	word ptr $S123,+000h
	jz	$L132
	mov	ax,$S123
	cmp	[bp-002h],ax
	jnc	$L133
$L134:	mov	ax,0001h
	mov	sp,bp
	pop	bp
	retf
$L133:	mov	ax,$S123
	sub	[bp-002h],ax
$L132:	cmp	word ptr [bp-002h],+018h
	jc	$L134
	sub	word ptr [bp-002h],+018h

	cmp	word ptr $S120,+000h
	jz	$L135
	mov	ax,$S120
	jmp	short $L136
$L135:	mov	ax,[bp-002h]
	sub	dx,dx
	mov	cx,0005h
	div	cx
$L136:	mov	[bp-00Ch],ax
	sub	ax,0030h
	sbb	cx,cx
	and	ax,cx
	add	ax,0030h
	mov	[bp-00Ch],ax
	cmp	[bp-002h],ax
	jc	$L134
	sub	[bp-002h],ax
	cmp	word ptr $S122,-001h
	jz	$L137
	cmp	word ptr $S122,+000h
	jz	$L138
	cmp	word ptr $S122,+010h
	jnc	$L138
$L137:	mov	word ptr [bp-006h],0000h
	jmp	short $L139
$L138:	call	far ptr __e_avail
	mov	[bp-00Ah],ax
	cmp	ax,0010h
	jc	$L140
	mov	ax,0001h
	jmp	short $L141
$L140:	sub	ax,ax
$L141:	mov	[bp-006h],ax
$L139:	cmp	word ptr [bp-006h],+000h
	jz	$L142
	cmp	word ptr $S122,+000h
	jz	$L143
	mov	ax,[bp-00Ah]
	sub	ax,$S122
	sbb	cx,cx
	and	ax,cx
	add	ax,$S122
	jmp	short $L144
	nop
$L143:	mov	ax,[bp-00Ah]
$L144:	mov	[bp-008h],ax
	sub	ax,0200h
	sbb	cx,cx
	and	ax,cx
	add	ah,02h
	mov	[bp-008h],ax
	cmp	word ptr $S121,+000h
	jnz	$L145
	mov	ax,[bp-002h]
	sub	dx,dx
	mov	cx,0003h
	div	cx
	mov	[bp-004h],ax
	cmp	ax,0040h
	jbe	$L146
	mov	word ptr [bp-004h],0040h
	jmp	short $L147
	nop
$L146:	cmp	word ptr [bp-004h],+020h
	jnc	$L147
$L148:	mov	word ptr [bp-004h],0000h
	jmp	short $L147
	nop
$L145:	cmp	word ptr $S121,-001h
	jz	$L148
	mov	ax,$S121
	jmp	short $L149
$L142:	cmp	word ptr $S121,+000h
	jnz	$L150
	mov	ax,[bp-002h]
	sub	dx,dx
	mov	cx,0003h
	div	cx
	jmp	short $L151
	nop
$L150:	cmp	word ptr $S121,-001h
	jnz	$L152
	mov	word ptr [bp-004h],0000h
	jmp	short $L153
$L152:	mov	ax,$S121
$L151:	mov	[bp-004h],ax
$L153:	mov	ax,[bp-004h]
	sub	ax,0010h
	sbb	cx,cx
	not	cx
	and	ax,cx
	add	ax,0010h
$L149:	mov	[bp-004h],ax
$L147:	mov	ax,[bp-004h]
	add	ax,0008h
	cmp	ax,[bp-002h]
	jbe	$L154
	jmp	$L134
$L154:	cmp	word ptr [bp-006h],+000h
	jz	$L155
	mov	ax,[bp-004h]
	add	ax,$S123
	push	ax
	call	far ptr __heap_init
	add	sp,+002h
	or	ax,ax
	jz	$L156
	jmp	$L134
$L156:	mov	ax,0001h
	push	ax
	push	[bp-008h]
	call	far ptr __blk_init
	add	sp,+004h
	or	ax,ax
	jnz	$L157
	jmp	$L134
	nop
$L155:	push	$S123
	call	far ptr __heap_init
	add	sp,+002h
	or	ax,ax
	jz	$L158
	jmp	$L134
$L158:	sub	ax,ax
	push	ax
	push	[bp-004h]
	call	far ptr __blk_init
	add	sp,+004h
	or	ax,ax
	jnz	$L157
	jmp	$L134
$L157:	call	far ptr __sym_init
	or	ax,ax
	jnz	$L159
	jmp	$L134
$L159:	mov	ax,002Eh
	mul	word ptr [bp-00Ch]
	mov	__mcount,ax
	mov	word ptr __mtop,0000h
	mov	word ptr __mbp,0000h
	mov	__ptop,ax
	mov	ax,0016h
	mul	word ptr __mcount
	push	ax
	mov	ax,offset DGROUP:__mstack
	push	ds
	push	ax
	push	cs
	call	__try_allocn
	add	sp,+006h
	or	ax,ax
	jnz	$L160
	jmp	$L134
$L160:	call	far ptr __mac_init
	or	ax,ax
	jnz	$L161
	jmp	$L134
$L161:	call	far ptr __ntx_init
	call	far ptr __term_init
	call	far ptr __stack_init
	or	ax,ax
	jnz	$L162
	jmp	$L134
$L162:	call	far ptr __db_init
	or	ax,ax
	jnz	$L163
	jmp	$L134
$L163:	call	far ptr __reef_init
	or	ax,ax
	jnz	$L164
	jmp	$L134
$L164:	sub	ax,ax
	mov	sp,bp
	pop	bp
	retf
	nop
_main:	push	bp
	mov	bp,sp
	sub	sp,+008h
	push	si
	push	cs
	call	$S165
	mov	[bp-008h],ax
	or	ax,ax
	jz	$L166
	jmp	$S167
$L166:	mov	ax,offset DGROUP:$S168
	push	ds
	push	ax
	call	far ptr __get_sym
	add	sp,+004h
	push	dx
	push	ax
	call	far ptr __putsym
	add	sp,+004h
	push	cs
	call	__DO
	mov	word ptr [bp-006h],0001h
	jmp	short $L169
	nop
$L170:	sub	ax,ax
	push	ax
	mov	bx,[bp-006h]
	shl	bx,1
	shl	bx,1
	les	si,dword ptr [bp+008h]
	push	es:[bx+si+002h]
	push	es:[bx+si]
	call	far ptr __putcs
	add	sp,+006h
	inc	word ptr [bp-006h]
$L169:	mov	ax,[bp-006h]
	cmp	[bp+006h],ax
	jnbe	$L170
	cmp	word ptr [bp+006h],+001h
	jng	$L171
	mov	ax,[bp+006h]
	dec	ax
	jmp	short $L172
	nop
$L171:	sub	ax,ax
$L172:	push	ax
	push	cs
	call	__SET_PC
	add	sp,+002h
	lea	ax,[bp-004h]
	push	ss
	push	ax
	call	far ptr __sym_count
	add	sp,+004h
	les	bx,dword ptr [bp-004h]
	push	es:[bx+01Eh]
	push	es:[bx+01Ch]
	call	far ptr __putsym
	add	sp,+004h
	push	cs
	call	__DO
	push	cs
	call	__QUIT
	sub	ax,ax
	push	ax
	call	far ptr __exit
	add	sp,+002h
	call	far ptr ERRORSYS
	pop	si
	mov	sp,bp
	pop	bp
	retf
	nop
$S167:	mov	ax,[bp-008h]
	cmp	ax,0001h
	jz	$L173
	cmp	ax,0002h
	jz	$L174
	jmp	short $L175
	nop
$L173:	mov	ax,0013h
	push	ax
	mov	ax,offset DGROUP:$S176
$L178:	push	ds
	push	ax
	call	far ptr __cout
	add	sp,+006h
	jmp	short $L175
	nop
$L174:	mov	ax,001Dh
	push	ax
	mov	ax,offset DGROUP:$S177
	jmp	short $L178
	nop
$L175:	cmp	word ptr __emm_stat,+000h
	jz	$L179
	push	__emm_handle
	call	far ptr __pid_cls
	add	sp,+002h
$L179:	call	far ptr __pend
	call	far ptr __kend
	call	far ptr __send
	mov	ax,0001h
	push	ax
	call	far ptr __exit
	add	sp,+002h
	pop	si
	mov	sp,bp
	pop	bp
	retf
	nop
__os_dir:
	push	bp
	mov	bp,sp
	sub	sp,00B8h
	push	di
	push	si
	les	bx,dword ptr __tos
	mov	ax,es:[bx+008h]
	mov	dx,es:[bx+00Ah]
	mov	[bp-078h],ax
	mov	[bp-076h],dx
	mov	ax,es:[bx+002h]
	mov	[bp-00B0h],ax
	les	bx,dword ptr [bp-078h]
	cmp	byte ptr es:[bx],00h
	jnz	$L180
	jmp	$S181
$L180:	lea	ax,[bp-074h]
	push	ss
	push	ax
	lea	ax,[bp-02Ch]
	push	ss
	push	ax
	lea	ax,[bp-072h]
	push	ss
	push	ax
	lea	ax,[bp-00A8h]
	push	ss
	push	ax
	lea	ax,[bp-07Ah]
	push	ss
	push	ax
	push	[bp-00B0h]
	push	dx
	push	bx
	call	far ptr __scan_filename
	add	sp,+01Ah
	mov	ax,[bp-07Ah]
	cmp	[bp-072h],ax
	jnz	$L182
	mov	ax,offset __default_drive
	push	ds
	push	ax
	call	far ptr _strlen
	add	sp,+004h
	mov	[bp-00AEh],ax
	mov	ax,[bp-074h]
	sub	ax,[bp-072h]
	mov	[bp-070h],ax
	mov	si,[bp-00AEh]
	add	si,ax
	cmp	si,+040h
	jnc	$L182
	push	[bp-00AEh]
	mov	ax,offset __default_drive
	push	ds
	push	ax
	lea	ax,[bp-06Ch]
	push	ss
	push	ax
	call	far ptr __bcopy
	add	sp,+00Ah
	push	[bp-070h]
	mov	ax,[bp-072h]
	add	ax,[bp-078h]
	mov	dx,[bp-076h]
	push	dx
	push	ax
	mov	di,[bp-00AEh]
	lea	ax,[bp+di-06Ch]
	push	ss
	push	ax
	call	far ptr __bcopy
	add	sp,+00Ah
	mov	byte ptr [bp+si-06Ch],00h
	lea	ax,[bp-06Ch]
	mov	[bp-078h],ax
	mov	word ptr [bp-076h],ss
	jmp	short $L182
$S181:	mov	ax,offset DGROUP:$S183
	mov	[bp-078h],ax
	mov	word ptr [bp-076h],ds
$L182:	sub	ax,ax
	push	ax
	lea	ax,[bp-00A6h]
	push	ss
	push	ax
	push	[bp-076h]
	push	[bp-078h]
	call	far ptr __f_first
	add	sp,+00Ah
	or	ax,ax
	jnz	$L184
	jmp	$S185
$L184:	call	far ptr __goutnl

	mov	ax,0027h
	push	ax
	mov	ax,0020h
	push	ax
	lea	ax,[bp-028h]
	push	ss
	push	ax
	call	far ptr __bset
	add	sp,+008h
	lea	ax,[bp-0088h]
	push	ss
	push	ax
	call	far ptr _strlen
	add	sp,+004h
	mov	[bp-02Ah],ax
	mov	ax,002Eh
	push	ax
	push	[bp-02Ah]
	lea	ax,[bp-0088h]
	push	ss
	push	ax
	call	far ptr __bscan
	add	sp,+008h
	mov	[bp-06Eh],ax
	push	ax
	lea	ax,[bp-0088h]
	push	ss
	push	ax
	lea	ax,[bp-028h]
	push	ss
	push	ax
	call	far ptr __bcopy
	add	sp,+00Ah
	mov	ax,[bp-02Ah]
	cmp	[bp-06Eh],ax
	jnc	$L186
	inc	word ptr [bp-06Eh]
	sub	ax,[bp-06Eh]
	push	ax
	mov	si,[bp-06Eh]
	lea	ax,[bp+si-0088h]
	push	ss
	push	ax
	lea	ax,[bp-01Fh]
	push	ss
	push	ax
	call	far ptr __bcopy
	add	sp,+00Ah
$L186:	push	[bp-008Ah]
	push	[bp-008Ch]
	call	far ptr __dvfml
	add	sp,+004h
	lea	di,[bp-00B8h]
	mov	si,ax
	push	ss
	pop	es
	push	ds
	mov	ds,dx
	movsw
	movsw
	movsw
	movsw
	pop	ds
	lea	ax,[bp-01Bh]
	push	ss
	push	ax
	sub	ax,ax
	push	ax
	mov	ax,0008h
	push	ax
	push	[bp-00B2h]
	push	[bp-00B4h]
	push	[bp-00B6h]
	push	[bp-00B8h]
	call	far ptr __ntoa
	add	sp,+010h
	mov	ax,[bp-008Eh]
	and	ax,0FE00h
	mov	cl,09h
	shr	ax,cl
	add	ax,07BCh
	push	ax
	mov	ax,[bp-008Eh]
	and	ax,01E0h
	mov	cl,05h
	shr	ax,cl
	push	ax
	mov	ax,[bp-008Eh]
	and	ax,001Fh
	push	ax
	call	far ptr __dmytod
	add	sp,+006h
	mov	[bp-00ACh],ax
	mov	[bp-00AAh],dx
	push	__date_mode
	push	dx
	push	ax
	lea	ax,[bp-011h]
	push	ss
	push	ax
	call	far ptr __dtoa
	add	sp,+00Ah
	mov	ax,0027h
	push	ax
	lea	ax,[bp-028h]
	push	ss
	push	ax
	call	far ptr __gout
	add	sp,+006h
	lea	ax,[bp-00A6h]
	push	ss
	push	ax
	call	far ptr __f_next
	add	sp,+004h
	or	ax,ax
	jz	$S185
	jmp	$L184
$S185:	call	far ptr __goutnl
	pop	si
	pop	di
	mov	sp,bp
	pop	bp
	retf
__os_copy:
	push	bp
	mov	bp,sp
	sub	sp,+00Eh
	mov	word ptr [bp-008h],0000h
	mov	word ptr [bp-00Ah],2000h
	jmp	short $L187
$L189:	cmp	word ptr [bp-00Ah],0100h
	jc	$L188
	shr	word ptr [bp-00Ah],1
$L187:	push	[bp-00Ah]
	lea	ax,[bp-00Eh]
	push	ss
	push	ax
	push	cs
	call	__try_allocn
	add	sp,+006h
	or	ax,ax
	jz	$L189
$L188:	cmp	word ptr [bp-00Ah],0100h
	jnc	$L190
	mov	word ptr __salt,0004h
	mov	word ptr __salt_memlen,0100h
	sub	ax,ax
	mov	sp,bp
	pop	bp
	retf
$L190:	mov	ax,0012h
	push	ax
	les	bx,dword ptr __tos
	push	es:[bx-006h]
	push	es:[bx-008h]
	call	far ptr __open_file
	add	sp,+006h
	mov	[bp-002h],ax
	cmp	ax,0FFFFh
	jz	$L191
	mov	ax,001Ah
	push	ax
	les	bx,dword ptr __tos
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	call	far ptr __open_file
	add	sp,+006h
	mov	[bp-004h],ax
	cmp	ax,0FFFFh
	jz	$L192
$L194:	push	[bp-00Ah]
	push	[bp-00Ch]
	push	[bp-00Eh]
	push	[bp-002h]
	call	far ptr __tread
	add	sp,+008h
	mov	[bp-006h],ax
	or	ax,ax
	jz	$L193
	push	ax
	push	[bp-00Ch]
	push	[bp-00Eh]
	push	[bp-004h]
	call	far ptr __twrite
	add	sp,+008h
$L193:	mov	ax,[bp-00Ah]
	cmp	[bp-006h],ax
	jz	$L194
	push	[bp-004h]
	call	far ptr __tclose
	add	sp,+002h
	jmp	short $L195
	nop
	nop
$L192:	mov	word ptr __salt,0005h
	mov	word ptr [bp-008h],0001h
$L195:	push	[bp-002h]
	call	far ptr __tclose
	add	sp,+002h
	jmp	short $L196
$L191:	mov	word ptr __salt,0005h
	mov	word ptr [bp-008h],0001h
$L196:	push	[bp-00Ah]
	push	[bp-00Ch]
	push	[bp-00Eh]
	push	cs
	call	__mem_release
	add	sp,+006h
	cmp	word ptr [bp-008h],+001h
	sbb	ax,ax
	neg	ax
	mov	sp,bp
	pop	bp
	retf
	nop
__os_type:
	push	bp
	mov	bp,sp
	sub	sp,+00Eh
	push	si
	call	far ptr __goutnl
	mov	ax,0200h
	push	ax
	lea	ax,[bp-00Ch]
	push	ss
	push	ax
	push	cs
	call	__mem_alloc
	add	sp,+006h
	or	ax,ax
	jnz	$L197
	mov	word ptr __salt,0004h
$S211:	sub	ax,ax
	pop	si
	mov	sp,bp
	pop	bp
	retf
	nop
$L197:	mov	ax,0012h
	push	ax
	les	bx,dword ptr __tos
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	call	far ptr __open_file
	add	sp,+006h
	mov	[bp-00Eh],ax
	cmp	ax,0FFFFh
	jnz	$L198
	jmp	$S199
$L198:	mov	word ptr [bp-008h],0000h
$S210:	cmp	word ptr [bp-008h],+000h
	jnz	$L200
	mov	ax,0200h
	push	ax
	push	[bp-00Ah]
	push	[bp-00Ch]
	push	[bp-00Eh]
	call	far ptr __tread
	add	sp,+008h
	mov	[bp-008h],ax
	or	ax,ax
	jnz	$L201
$L207:	push	[bp-00Eh]
	call	far ptr __tclose
	add	sp,+002h
	mov	ax,0200h
	push	ax
	push	[bp-00Ah]
	push	[bp-00Ch]
	push	cs
	call	__mem_release
	add	sp,+006h
	jmp	$S202
	nop
$L201:	mov	ax,[bp-00Ch]
	mov	dx,[bp-00Ah]
	mov	[bp-004h],ax
	mov	[bp-002h],dx
$L200:	mov	word ptr [bp-006h],0000h
	jmp	short $L203
	nop
$L205:	mov	bx,[bp-006h]
	les	si,dword ptr [bp-004h]
	cmp	byte ptr es:[bx+si],1Ah
	jbe	$L204
	inc	word ptr [bp-006h]
$L203:	mov	ax,[bp-008h]
	cmp	[bp-006h],ax
	jc	$L205
$L204:	push	[bp-006h]
	push	[bp-002h]
	push	[bp-004h]
	call	far ptr __gout
	add	sp,+006h
	mov	ax,[bp-008h]
	cmp	[bp-006h],ax
	jnc	$L206
	mov	bx,[bp-006h]
	les	si,dword ptr [bp-004h]
	cmp	byte ptr es:[bx+si],1Ah
	jz	$L207
	cmp	byte ptr es:[bx+si],0Ah
	jnz	$L208
	call	far ptr __goutnl
	jmp	short $L209
	nop
$L208:	mov	bx,[bp-006h]
	les	si,dword ptr [bp-004h]
	cmp	byte ptr es:[bx+si],0Dh
	jz	$L209
	mov	ax,0001h
	push	ax
	mov	ax,bx
	add	ax,si
	mov	dx,es
	push	dx
	push	ax
	call	far ptr __gout
	add	sp,+006h
$L209:	inc	word ptr [bp-006h]
$L206:	mov	ax,[bp-006h]
	add	[bp-004h],ax
	sub	[bp-008h],ax
	jmp	$S210
	nop
$S199:	mov	ax,0200h
	push	ax
	push	[bp-00Ah]
	push	[bp-00Ch]
	push	cs
	call	__mem_release
	add	sp,+006h
	mov	word ptr __salt,0005h
	jmp	$S211
$S202:	mov	ax,0001h
	pop	si
	mov	sp,bp
	pop	bp
	retf
__DOS_CALL:
	push	bp
	mov	bp,sp
	sub	sp,0102h
	mov	word ptr [bp-0102h],0000h
	les	bx,dword ptr __tos
	test	word ptr es:[bx],0100h
	jnz	$L212
	jmp	$S213
$L212:	mov	ax,[bp+006h]
	or	ax,ax
	jz	$L214
	cmp	ax,0001h
	jz	$L215
	cmp	ax,0002h
	jnz	$L216
	jmp	$S217
$L216:	cmp	ax,0003h
	jnz	$L218
	jmp	$S219
$L218:	cmp	ax,0004h
	jnz	$L220
	jmp	$S221
$L220:	cmp	ax,0005h
	jnz	$L222
	jmp	$S223
$L222:	mov	sp,bp
	pop	bp
	retf
	nop
$L214:	cmp	word ptr es:[bx+002h],+000h
	jz	$L224
	push	cs
	call	__os_dir
	jmp	short $L225
	nop
$L224:	call	far ptr __dbf_dir
$L225:	call	far ptr __pull1
	mov	sp,bp
	pop	bp
	retf
$L215:	cmp	word ptr __emm_stat,+000h
	jnz	$L226
	call	far ptr __ntx_end

	call	far ptr __blk_shrink
$L226:	les	bx,dword ptr __tos
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	call	far ptr __system
	add	sp,+004h
	mov	[bp-0102h],ax
	or	ax,ax
	jz	$L227
	mov	word ptr __salt,0010h
	jmp	short $L228
	nop
$L227:	call	far ptr __pull1
$L228:	cmp	word ptr __emm_stat,+000h
	jnz	$L229
	call	far ptr __blk_grow
	call	far ptr __ntx_init
$L229:	sub	ax,ax
	push	ax
	mov	ax,__maxrow
	dec	ax
	push	ax
	call	far ptr __setcurs
	add	sp,+004h
	mov	sp,bp
	pop	bp
	retf
$S217:	push	cs
	call	__os_copy
	or	ax,ax
	jz	$L230
$L231:	call	far ptr __pull2
	mov	sp,bp
	pop	bp
	retf
	nop
$S219:	les	bx,dword ptr __tos
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	call	far ptr __tunlink
	add	sp,+004h
	jmp	$L225
	nop
$S221:	les	bx,dword ptr __tos
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	push	es:[bx-006h]
	push	es:[bx-008h]
	call	far ptr __trename
	add	sp,+008h
	jmp	short $L231
$S223:	push	cs
	call	__os_type
	or	ax,ax
	jz	$L230
	jmp	$L225
	nop
$S213:	mov	word ptr __salt,0001h
$L230:	mov	sp,bp
	pop	bp
	retf
__FILE: mov	word ptr __xframe0,0080h
	mov	ax,0013h
	push	ax
	push	__xframe1 + 0000Ah
	push	__xframe1 + 00008h
	call	far ptr __open_file
	add	sp,+006h
	cmp	ax,0FFFFh
	jz	$L232
	mov	ax,0001h
	mov	__xframe0 + 00008h,ax
	retf
$L232:	sub	ax,ax
	mov	__xframe0 + 00008h,ax
	retf
__MEMORY:
	push	bp
	mov	bp,sp
	sub	sp,+006h
	mov	word ptr __xframe0,0002h
	mov	word ptr __xframe0 + 00002h,000Ah
	mov	ax,__xframe1 + 00008h
	or	ax,__xframe1 + 0000Ah
	jnz	$L233
	call	far ptr __mem_snap
	mov	ax,__snap_total
	mov	__xframe0 + 00008h,ax
	mov	word ptr __xframe0 + 0000Ah,0000h
	mov	sp,bp
	pop	bp
	retf
$L233:	sub	ax,ax
	mov	__xframe0 + 0000Ah,ax
	mov	__xframe0 + 00008h,ax
	mov	sp,bp
	pop	bp
	retf
__PCOUNT:
	mov	word ptr __xframe0,0002h
	mov	word ptr __xframe0 + 00002h,000Ah
	mov	ax,$S7
	mov	__xframe0 + 00008h,ax
	mov	word ptr __xframe0 + 0000Ah,0000h
	retf
	nop
__LINE: push	bp
	mov	bp,sp
	mov	ax,[bp+006h]
	mov	__line_num,ax
	cmp	word ptr __debug_active,+000h
	jz	$L234
	call	far ptr __debug
$L234:	pop	bp
	retf
	nop
ERRORLEVEL:
	push	bp
	mov	bp,sp
	sub	sp,+002h
	mov	ax,$S45
	mov	[bp-002h],ax
	cmp	word ptr __param_count,+000h
	jz	$L235
	les	bx,dword ptr __tos
	test	byte ptr es:[bx],08h
	jz	$L236
	push	es:[bx+00Eh]
	push	es:[bx+00Ch]
	push	es:[bx+00Ah]
	push	es:[bx+008h]
	call	far ptr __dvtoq
	add	sp,+008h
	jmp	short $L237
	nop
$L236:	les	bx,dword ptr __tos
	cmp	word ptr es:[bx],+002h
	jnz	$L235
	mov	ax,es:[bx+008h]
$L237:	mov	$S45,ax
$L235:	push	[bp-002h]
	call	far ptr __putq
	add	sp,+002h
	push	cs
	call	__SAVE_RET
	mov	sp,bp
	pop	bp
	retf
SETCANCEL:
	push	bp
	mov	bp,sp
	sub	sp,+002h
	mov	ax,__altc_on
	mov	[bp-002h],ax
	cmp	word ptr __param_count,+001h
	jnz	$L238
	les	bx,dword ptr __tos
	cmp	word ptr es:[bx],0080h
	jnz	$L238
	mov	ax,es:[bx+008h]
	mov	__altc_on,ax
$L238:	push	[bp-002h]
	call	far ptr __putl
	add	sp,+002h
	push	cs
	call	__SAVE_RET
	mov	sp,bp
	pop	bp
	retf

MAIN_TEXT	ENDS

_DATA	SEGMENT


__vcsize	dw	00000h
__altc_on	dw	00001h
SUMMER87	db	000h
	db	000h
$S120	dw	00000h
$S121	dw	00000h
$S122	dw	00000h
$S123	dw	00000h
$S124	dw	00000h
$S125	dw	00000h
__quitting	dw	00000h
__line_num	dw	00000h
__param_count	dw	00000h
$S7	dw	00000h
$S8	dw	00000h
__mstack	dw	00000h
$S14	dw	00000h
__mcount	dw	00000h
__mtop	dw	00000h
__mbp	dw	00000h
__ptop	dw	00000h
__date_mode	dw	00001h
$S45	dw	00000h

_DATA	ENDS

CONST	SEGMENT


$S33	db	000h

	db	1 dup(?)
$S43	db	01Ah
	db	000h
$S48	db	'(mv)',000h

	db	1 dup(?)
$S50	db	'(pv)',000h

	db	1 dup(?)
$S61	db	'<begin>',000h
$S111	db	'CLIPPER',000h
$X111	db	'EPOCH',000h                    ;added 01-may-1998
$S168	db	'ERRORSYS',000h

	db	1 dup(?)
$S176	db	'Not enough memory',00Dh,00Ah,000h
$S177	db	'Error in =Fnnn file handles',00Dh,00Ah,000h
$S183	db	'*.*',000h

CONST	ENDS

	END

